
var discussPref = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService)
                            .getBranch(null);

//var fullPath;                // fullpath to tempBuffer
var isEditorLoaded = false;  // editor loaded flag
var editorHandle;            // Editor instance
var editorShell;	         // editorShell instance
var gContentWindow;
var rdfStore    = new rdfRepository();
var globalState = new mozblogState();
var tmpStore    = new tempStorage();

initMozblog();

function initMozblog()
{
/*  var du = new DirUtils();
  var userDir = du.getMozUserHomeDir();
  var fu = new FileUtils();
  fullPath = fu.append(userDir, "discussTmp.html");*/
  loadRDF("discussProfile.rdf", "profile");
  loadRDF("blogHistory.rdf", "blogHistory");
}

function hideDoc()
{
  var doc = document.getElementById('bottomBar');
  var splitter = document.getElementById('discussSplit');
  if (doc.collapsed == false || splitter.collapsed == false)
  {
    doc.collapsed = true;
    splitter.collapsed = true;
    window._content.focus();
    document.getElementById('bottombarMenu').setAttribute('checked', 'false');
    tmpStore.save();              // save tmp file
  } else {                        // open discuss
    doc.collapsed = false;
    splitter.collapsed = false;
    if (!isEditorLoaded) {		  // init editor instance if not already done so
      editorHandle = new Editor("discussEditorType", "edit-frame", "scraptDocument");
      setDefaultView();
      populateBlogID();
      populatePostHistory();
      isEditorLoaded = true;
    }
    document.getElementById('bottombarMenu').setAttribute('checked', 'true');
    editorHandle.focus();
  }
}

function setDefaultView()
{
  try {
    var defaultView = discussPref.getBoolPref("discuss.defaultSourceView");
  } catch (e) {
    defaultView = false;
  }

  if (defaultView) { //if default as source view
    document.getElementById('discussEditorType').setAttribute('selectedIndex','1');
    document.getElementById('sourceView').setAttribute("checked", true);
    editorHandle.editorShell.SetDisplayMode(3);
  } else {
    document.getElementById('htmlView').setAttribute("checked", true);
    editorHandle.viewHtml();
  }
}

function populatePostHistory()
{
  var ds           = rdfStore.getSource("blogHistory");
  var RDF          = Components.classes['@mozilla.org/rdf/rdf-service;1']
					                     .getService(Components.interfaces.nsIRDFService);
  var RDFContainer = Components.classes["@mozilla.org/rdf/container;1"]
  							               .getService(Components.interfaces.nsIRDFContainer);
  RDFContainer.Init(ds, RDF.GetResource("http://www.exitspace.net/blog/posts"));
  var postHistBox = document.getElementById("prevBlogPostList");
  var itemCount   = 0;
  var postHandle  = null;
  var postList    = RDFContainer.GetElements();
  while (postList.hasMoreElements() && itemCount < 10) {
    postHandle = postList.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    var postTitle = getRDFAttribute(ds, postHandle, "http://purl.org/dc/elements/1.1/date");
//	var postValue = getRDFAttribute(ds, postHandle, "http://www.exitspace.net/blog/postid");
    var postChan  = getRDFAttribute(ds, postHandle, "http://www.exitspace.net/blog/blogid");
//	alert(postChan + ":" + globalState.blogID);
    if (postChan == globalState.blogID) {
      postHistBox.appendItem(postTitle, postHandle.Value);
    itemCount++;
    }
  }
}

function statusReport(message)
{
  document.getElementById("statusbar-display").label = message;
}

function testRegex()
{
try{
  var gWeb = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor);
  var gWebBrowser = gWeb.QueryInterface(Components.interfaces.nsIWebBrowser);
  var gDocDom = window.QueryInterface(Components.interfaces.nsIDOMWindow);
  var editWindow = gDocDom.QueryInterface(Components.interfaces.nsIEditingSession);
  editWindow.init(gDocDom);
  editWindow.makeWindowEditable(gDocDom,true);
  } catch(e){
  alert(e);
  }
  alert(typeof gWebBrowser);
}