function populateBlogID()
{
  var blogNS        = "http://www.exitspace.net/blog/";
  var ds			= rdfStore.getSource("profile");
  var RDF	        = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                                .getService(Components.interfaces.nsIRDFService);
  var serverRDFList = Components.classes["@mozilla.org/rdf/container;1"]
                                .getService(Components.interfaces.nsIRDFContainer);

  var serverList    = document.getElementById("blogIDs");
  var mozblogNS     = RDF.GetResource("http://www.exitspace.net/blog");
  var defaultValue  = null;
  var count         = 0;

  serverRDFList.Init(ds, mozblogNS);
  var serverEnumerator = serverRDFList.GetElements();

  // load the last used channel (persistant)
  var defaultIndex = getRDFAttribute(ds, mozblogNS, blogNS+"BlogIDdefaultIndex");
  try {
  	defaultIndex = parseInt(defaultIndex);
  } catch (e) {
	defaultIndex = 0;
  }

  while (serverEnumerator.hasMoreElements()) {
    var blogIdItem = serverEnumerator.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    var blogID     = getRDFAttribute(ds, blogIdItem, blogNS+"siteID");
    var blogName   = getRDFAttribute(ds, blogIdItem, blogNS+"siteName");
	serverList.insertItemAt(count, blogName, blogID);
	if(count++ == defaultIndex)
	  defaultValue = blogID;
  }

  serverList.selectedIndex = defaultIndex;
  globalState.blogID = defaultValue;
}

/**
 * chooseChannel is called when the user switch a upstream channel
 * usually used to load the sub channel
 */
function chooseChannel()
{

  // update the new default channel
  var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1']
	  				  .getService(Components.interfaces.nsIRDFService);
  var ds = getRDFHandle("discussProfile.rdf");
  var blogNS = RDF.GetResource('http://www.exitspace.net/blog');
  var blogDefaultIndex = RDF.GetResource('http://www.exitspace.net/blog/BlogIDdefaultIndex');
  var newDefaultIndex = RDF.GetLiteral(document.getElementById("blogIDs").selectedIndex);
  updateAssertion(ds, blogNS, blogDefaultIndex, newDefaultIndex);
  var localRDS = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
  localRDS.Flush();
  ds = null;

  // change change change
  var channelType = "";
  var localTempPosts = document.getElementById("post");
  var localTempPublish = document.getElementById("publish");
  var localTempDelete = document.getElementById("delete");
  var localTempPostIds = document.getElementById("prevBlogPostList");
  var newChannelIndex = document.getElementById("blogIDs").selectedItem.value;
  globalState.blogID = newChannelIndex;

  var metaTextbox = document.getElementById("metaTextbox");
  if (isNaN(newChannelIndex)) {
    //		  getSubChannels();
    if (newChannelIndex == 'Localstore') {
      channelType = "local";
      localRecentFile();
    }
  } else {
    channelType="blog";
    getRecentPosts(retrievePost);
  }
  localTempPosts.removeAttribute("oncommand");
  localTempPublish.removeAttribute("oncommand");
  localTempDelete.removeAttribute("oncommand");
  localTempPostIds.removeAttribute("onselect");
  localTempPosts.setAttribute("oncommand", channelType+"Post(false);");
  localTempPublish.setAttribute("oncommand", channelType+"Post(true);");
  localTempDelete.setAttribute("oncommand", "delete"+channelType+"Post();");
  localTempPostIds.setAttribute("onselect", "editorHandle.clearMeta();tmpStore.save();get"+channelType+"Content();");
  //localRecentFile();
}


/**
 * loadChannels parse the plugin directory for plugins that might be installed and call their constructor
 */
/*function loadChannels()
{
	var pluginFilename;
	var pluginIndex = document.getElementById("blogIDs");
	var pluginDir = new Dir(chromeDir);
	pluginDir.append("discuss");
	pluginDir.append("plugins");
	if (!pluginDir.exists()) {
	  pluginDir.create();
	}
	if (pluginDir.isDir()) {
	  var dirListing = pluginDir.readDir();
	  for (var i = 0; i < dirListing.length; i++) {
		pluginFilename = dirListing[i].leaf;
		var base = pluginFilename.slice(0, pluginFilename.lastIndexOf("."));
		if(dirListing[i].isFile()) {
		  if(include(dirListing[i].URL) == false) {
//			  alert(base);
			var pluginTitle = eval(base + "();");
			pluginIndex.appendItem(pluginTitle, base);
//			  pluginIndex.setAttribute('onclick', 'alert("cool");');
		  }
		}
	  } // loop dir for files
	} // plugin dir exist
}*/