
var mozblogState = function() {}

mozblogState.prototype = {
  get content()	{
	return this.editorContent;
  },
  set content(content) {
    this.editorContent = content;
  },
  get title() {
    if (!this.contentTitle || this.contentTitle == "")
    {
      var whitespace = /\s+/gi;
      var htmlTag = /<[^<>]*>/gi;
      var stripContent = this.editorContent.replace(whitespace, " ");
      stripContent = stripContent.replace(htmlTag, "");
      this.contentTitle = stripContent.slice(0,100);
      var lastFullStopIndex = this.contentTitle.lastIndexOf(".");
      if (lastFullStopIndex > 0)
        this.contentTitle = this.contentTitle.slice(0,lastFullStopIndex+1);
    }
    return this.contentTitle;
  },
  set title(title) {
    this.contentTitle = title;
  },
  get description() {
    if (!this.contentDescription || this.contentDescription == "")
    {
      var whitespace = /\s+/gi;
      var htmlTag = /<[^<>]*>/gi;
      var stripContent = this.editorContent.replace(whitespace, " ");
      stripContent = stripContent.replace(htmlTag, "");
      this.contentDescription = stripContent.slice(0,500);
      var lastFullStopIndex = this.contentDescription.lastIndexOf(".");
      if (lastFullStopIndex > 0)
        this.contentDescription = this.contentDescription.slice(0,lastFullStopIndex+1);
    }
    return this.contentDescription;
  },
  set description(desc)	{
    this.contentDescription = desc;
  },
  get category() {
    return this.contentCategory;
  },
  set category(category) {
    this.contentCategory = category;
  },
  get postID() {
    return this.contentID;
  },
  set postID(postId) {
    this.contentID = postId;
  },
  get blogID() {
    return this.blogServerID;
  },
  set blogID(blogId) {
	this.blogServerID = blogId;
  },
  clearState : function() {
    this.editorContent = "";
    this.contentTitle = "";
    this.contentDescription = "";
    this.contentCategory = "";
    this.contentID = "";
    this.blogServerID = "";
  },
  saveToDisk : function() {
    var ds = rdfStore.getSource("blogHistory");
    var title = transformTitle(this.title);
    try {
      var localDir = discussPref.getCharPref("localstore.directory");
    } catch (e) {
      defaultView = "urn:";
    }

    var blogLoc  = localDir + title + ".html";
    var testLocal = new localStore(null);
    testLocal.saveFile(title + ".html", this.content);
/*    if (localStoreSandbag())
      saveLocalPost((localStoreDir + title + ".html"), this.content);*/

    var postDateNS = "http://purl.org/dc/elements/1.1/date";
	var date = new Date();
	var postDateValue = date.toUTCString();

	setRDFAttribute(ds, blogLoc, "http://www.exitspace.net/blog/postid", this.postID, true);
//    setRDFAttribute(ds, blogLoc, "http://www.exitspace.net/blog/blogid", currentChannel(), true);
	setRDFAttribute(ds, blogLoc, "http://purl.org/dc/elements/1.1/date", postDateValue, true);
	setRDFAttribute(ds, blogLoc, "http://purl.org/rss/1.0/title", this.contentTitle, true);
	setRDFAttribute(ds, blogLoc, "http://purl.org/rss/1.0/description", this.contentDescription, true);
//	setRDFAttribute(ds, blogLoc, "http://www.w3.org/1999/02/22-rdf-syntax-ns#type", this.contentDescription, true);
//	setRDFAttribute(blogLoc, "http://purl.org/dc/elements/1.1/subject", this.category, true);
	addPostToList(ds, blogLoc);

    var localRDS = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	localRDS.Flush();
    ds = null;
    this.clearState();
  }
}

// save the posts metadata, due to architecture design, it also generate the filename and save file to disk
function savePostMetadata(postID)
{
}

// transform the title into a valid filename
function transformTitle(title)
{
  var invalidChar = /\/|\\|:|\*|\?|<|>|\|/gi;
  if(title.length != 0)	{
	title = title.replace(invalidChar, "");
    title = title.replace(/\s+/gi, "_");
	if (title.charAt(title.length-1) == '_')
      title = title.substring(0, title.length - 1);
  } else {
    var today = new Date();
	title = today.getDate() + "-" + today.getMonth() + "-" + (1900 + today.getYear());
  }
  return title;
}

// add the post link to the list of history
function addPostToList(ds, titleKey)
{
  var RDF          = Components.classes['@mozilla.org/rdf/rdf-service;1']
					           .getService(Components.interfaces.nsIRDFService);
  var RDFContainer = Components.classes["@mozilla.org/rdf/container;1"]
	   		                   .getService(Components.interfaces.nsIRDFContainer);
  var RDFContainerUtils = Components.classes["@mozilla.org/rdf/container-utils;1"]
                               .getService(Components.interfaces.nsIRDFContainerUtils);
  var blogPostList = RDF.GetResource('http://www.exitspace.net/blog/posts');
  if (!RDFContainerUtils.IsContainer(ds, blogPostList))
  {
    RDFContainer = RDFContainerUtils.MakeSeq(ds, blogPostList);
  }
  RDFContainer.Init(ds, blogPostList);
  var index = RDFContainer.IndexOf(RDF.GetResource(titleKey));
  if (index == -1) // none existed
    RDFContainer.InsertElementAt(RDF.GetResource(titleKey), 1, true);
  ds = null;
}