/* xmlrpc manager.
 * It implements a queue that manages the xmlrpc invocation, so no conflicting calls
 * It works by calling addCommand() which accept 3 parameters
 * the serverurl, the methodname and an arry of parameters
 */
var xmlrpcManager = function() 
{
  this.init();
}

xmlrpcManager.prototype = {
  xmlRpc : null,         // the xmlrpc component instance
	busy : false,          // if there is a call in progress
	currentIndex : 0,      // the index to insert to
	commandQueue : null,   // the queue for methods
	currentCommand : null, // the currently executed method
	
	init : function()
	{
	  this.commandQueue = new Array();
	  this.xmlRpc = Components.classes["@mozilla.org/xml-rpc/client;1"]
		        			          .createInstance(Components.interfaces.nsIXmlRpcClient);
	},

  // append new methods, and try to execute it
	addCommand : function(serverUrl, method, parameter, listener)
	{
	  this.commandQueue[this.commandQueue.length] = new Array(serverUrl, method, parameter, listener);
		this.currentIndex++;
		if (!this.busy)
		  this.execute();
	},
	
	execute : function()
	{
	  if (this.commandQueue.length > 0)
		{
		  this.currentCommand = this.commandQueue.shift();
		  this.xmlRpc.init(this.currentCommand[0]);
			this.xmlRpc.asyncCall(this, null, this.currentCommand[1], 
			                      this.currentCommand[2], this.currentCommand[2].length);
		  this.busy = true;
		}
	},
	
  onResult : function(client, ctxt, result)
	{
		eval(this.currentCommand[3] + "(result, null)");
		this.busy = false;
		this.execute();
	}, onFault: function(client, ctxt, fault) {
		alert("Fault! " + fault + "\n");
		this.execute();
	}, onError: function(client, ctxt, status, errorMsg) {
		alert("Error! (" + status.toString(16) + ") " + errorMsg + "\n");
		this.execute();
	}
}

var fooManager = new xmlrpcManager();

function testingBlogger()
{
getUserBlog2();
}
function getUserBlog2()
{
	var serverurl2 = "http://plant.blogger.com/api/RPC2";
	var blogAppKey2 = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces["nsISupportsString"])
	var username2 = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces["nsISupportsString"]);
	var password2 = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces["nsISupportsString"]);
	/*var blogAppKey2 = xmlRpc.createType(xmlRpc.STRING, {});
	var username2 = xmlRpc.createType(xmlRpc.STRING, {});
	var password2 = xmlRpc.createType(xmlRpc.STRING, {});	*/
	blogAppKey2.data = "27927D1C57D2F831AE13A9A07099843A3CCA2DE0";
	username2.data = "tseng_mike";
//	alert(testTypeOf(password2));
//	alert(blogAppKey2.toString() + " " + username2.toString() + " " + password2.toString());
	var tempArray = new Array(blogAppKey2 , username2, password2);
//  fooManager.addCommand(serverurl2, "blogger.getUsersBlogs", tempArray, "getUsersBlogs");
	
  xmlRpc = Components.classes["@mozilla.org/xml-rpc/client;1"]
	    			          .createInstance(Components.interfaces.nsIXmlRpcClient);
  xmlRpc.init(serverurl2);
	xmlRpc.asyncCall(xmlrpcManager, null, "blogger.getUsersBlogs", tempArray, 3);	
}											

function getUserInfo2()
{
	var serverurl2 = "http://plant.blogger.com/api/RPC2";
	var blogAppKey2 = xmlRpc.createType(xmlRpc.STRING, {});
	var username2 = xmlRpc.createType(xmlRpc.STRING, {});
	var blogid2 = xmlRpc.createType(xmlRpc.STRING, {});
	var password2 = xmlRpc.createType(xmlRpc.STRING, {});
	blogAppKey2.data = "27927D1C57D2F831AE13A9A07099843A3CCA2DE0";
	username2.data = "tseng_mike";
	blogid2.data = "3006507";
	var tempArray = new Array(blogAppKey2, blogid2, username2, password2);
	fooManager.addCommand(serverurl2, "blogger.getPost", tempArray, "getUsersBlogs");
}

function getUsersBlogs(result, message)
{
		var blogInfoResult = result.QueryInterface(Components.interfaces.nsISupportsArray);
		for (i = 0; i < blogInfoResult.Count(); i++) {
			dictResult = blogInfoResult.QueryElementAt(i, Components.interfaces.nsIDictionary);
			dictResult1 = dictResult.getValue("blogName");
			dictResult2 = dictResult.getValue("blogid");
			dictResult1 = dictResult1.QueryInterface(Components.interfaces.nsISupportsString);
			dictResult2 = dictResult2.QueryInterface(Components.interfaces.nsISupportsString);
			alert(i + 1 + " " + dictResult1.data + " " + dictResult2.data);
		}
}

function testTypeOf(obj) {
        // XPConnect alows JS to pass in anything, because we are a regular
        // JS object to it. So we have to test rigorously.
        if (typeof obj != 'object') return 'Unknown';

        // Anything else not nsISupports is not allowed.
        if (typeof obj.QueryInterface != 'function') return 'Unknown';

        // Now we will have to eliminate by trying all possebilities.
        try {
            obj.QueryInterface(Components.interfaces.nsISupportsPRUint8);
            return 'PRUint8';
        } catch(e) {}
        
        try {
            obj.QueryInterface(Components.interfaces.nsISupportsPRUint16);
            return 'PRUint16';
        } catch(e) {}
        
        try {
            obj.QueryInterface(Components.interfaces.nsISupportsPRInt16);
            return 'PRInt16';
        } catch(e) {}
        
        try {
            obj.QueryInterface(Components.interfaces.nsISupportsPRInt32);
            return 'PRInt32';
        } catch(e) {}
        
        try {
            obj.QueryInterface(Components.interfaces.nsISupportsPRBool);
            return 'PRBool';
        } catch(e) {}
        
        try {
            obj.QueryInterface(Components.interfaces.nsISupportsChar);
            return 'Char';
        } catch(e) {}
        
        try {
            obj.QueryInterface(Components.interfaces.nsISupportsString);
            return 'String';
        } catch(e) {}
        
        try {
            obj.QueryInterface(Components.interfaces.nsISupportsFloat);
            return 'Float';
        } catch(e) {}
        
        try {
            obj.QueryInterface(Components.interfaces.nsISupportsDouble);
            return 'Double';
        } catch(e) {}
        
        try {
            obj.QueryInterface(Components.interfaces.nsISupportsPRTime);
            return 'PRTime';
        } catch(e) {}
        
        try {
            obj.QueryInterface(Components.interfaces.nsIInputStream);
            return 'InputStream';
        } catch(e) {}
        
        try {
            obj.QueryInterface(Components.interfaces.nsISupportsArray);
            return 'Array';
        } catch(e) {}
        
        try {
            obj.QueryInterface(Components.interfaces.nsIDictionary);
            return 'Dictionary';
        } catch(e) {}
        
        // Not a supported type
        return 'Unknown';
    }
