
function createProfile(discussFile)
{
  var fileOut = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance();
  var outStream = fileOut.QueryInterface(Components.interfaces.nsIFileOutputStream);
  var discussDefault = '<?xml version="1.0"?>\n<RDF:RDF xmlns:RDF=';
  discussDefault	  += '"http://www.w3.org/1999/02/22-rdf-syntax-ns#"\n';
  discussDefault	  += 'xmlns:ES="http://www.exitspace.net/blog/"\n';
  discussDefault	  += 'xmlns:NC="http://home.netscape.com/NC-rdf#">\n';
  discussDefault	  += '<RDF:Seq about="http://www.exitspace.net/blog">\n';
  discussDefault	  += '</RDF:Seq>\n';
  discussDefault	  += '</RDF:RDF>\n';

  // flag from nsIFile.idl
  var NORMAL_FILE_TYPE = 0;
  // flags from prio.h [ http://lxr.mozilla.org/seamonkey/source/nsprpub/pr/include/prio.h ]
  var WRITE_ONLY		 = 0x02;
  var OWNER_WRITE 	 = 00200;

  discussFile.create(NORMAL_FILE_TYPE, 755);
  outStream.init(discussFile, WRITE_ONLY, OWNER_WRITE, 0);
  outStream.write(discussDefault, discussDefault.length);
  outStream.close();
}

function getRDFHandle(filename)
{
  var profileComponent = Components.classes["@mozilla.org/profile/manager;1"].createInstance();
  var profileInternal = profileComponent.QueryInterface(Components.interfaces.nsIProfileInternal);
  var discussFile = profileInternal.getProfileDir(profileInternal.currentProfile);
  discussFile.append(filename);
  if (!discussFile.exists())
  {
    dump("creating new mozblog datasource");
    createProfile(discussFile);
  }

  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                            .getService(Components.interfaces.nsIIOService);
  var discussUrl = ioService.newFileURI(discussFile);
  var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1']
                      .getService(Components.interfaces.nsIRDFService);
  ds = RDF.GetDataSource(discussUrl.spec);
  return ds;
}

function updateAssertion(ds, subject, predicate, newValue)
{
  var oldValue = ds.GetTarget(subject, predicate, true);
  if (oldValue)
    ds.Change(subject, predicate, oldValue, newValue);
  else
    ds.Assert(subject, predicate, newValue, true);
  ds = null;
}

function setRDFAttribute(ds, subject, predicate, newValue)
{
  var RDF          = Components.classes['@mozilla.org/rdf/rdf-service;1']
                               .getService(Components.interfaces.nsIRDFService);
  subject   = RDF.GetResource(subject);
  predicate = RDF.GetResource(predicate);
  newValue  = RDF.GetLiteral(newValue);
  var oldValue = ds.GetTarget(subject, predicate, true);
  if (oldValue)
    ds.Change(subject, predicate, oldValue, newValue);
  else
    ds.Assert(subject, predicate, newValue, true);
  ds = null;
}

function getRDFAttribute(ds, subject, predicate)
{
  var RDF          = Components.classes['@mozilla.org/rdf/rdf-service;1']
                               .getService(Components.interfaces.nsIRDFService);
  if (typeof subject == "string") {
    subject = RDF.GetResource(subject);
  }
  predicate = RDF.GetResource(predicate);
  var value = ds.GetTarget(subject, predicate, true);
  if (value) {
    return value.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
  }
}

function loadRDF(filename, keyname)
{
  var mozblogDs = getRDFHandle(filename);
  rdfStore.insertSource(keyname, mozblogDs);

  var localRDS = mozblogDs.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
  if (localRDS.loaded)
  {
    dump("the datasource was already loaded! " + filename + "\n");
  }
  else
  {
    dump("the datasource wasn't loaded, but it's loading now! " + filename + "\n");
    var sink = mozblogDs.QueryInterface(Components.interfaces.nsIRDFXMLSink);
    sink.addXMLSinkObserver(discussObserver);
  }
  mozblogDs = null;
}

var discussObserver = {
  onBeginLoad: function(aSink) {},
  onInterrupt: function(aSink) {},
  onResume: function(aSink)	 {},
  onEndLoad: function(aSink)
  {
    dump("data source for mozblog finish loading!\n");
    aSink.removeXMLSinkObserver(discussObserver);
  },
  onError: function(aSink, aStatus, aErrorMsg) { alert("error! " + aErrorMsg); }
};
