
  var ds  = getRDFHandle("discussProfile.rdf");
  var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1']
					  .getService(Components.interfaces.nsIRDFService);

  function loadPref()
  {
	if (opener.selectedServer)
	{
//		alert(opener.selectedServer);
	  var RDFContainer = Components.classes["@mozilla.org/rdf/container;1"]
								   .getService(Components.interfaces.nsIRDFContainer);

	  var BlogSrvContainerNS = RDF.GetResource(opener.selectedServer);
	  var blogSrvUrlNS = RDF.GetResource("http://www.exitspace.net/blog/serverUrl");
	  var blogAppKeyNS = RDF.GetResource("http://www.exitspace.net/blog/appKey");
	  var blogUserNameNS = RDF.GetResource("http://www.exitspace.net/blog/username");
	  var blogPingBlogNS = RDF.GetResource("http://www.exitspace.net/blog/pingBlog");
	  var blogRetrieveNumNS = RDF.GetResource("http://www.exitspace.net/blog/retrieveNum");

	  setTextFieldValue("bloggerServer", getTargetValue(BlogSrvContainerNS, blogSrvUrlNS));
	  setTextFieldValue("bloggerAppkey", getTargetValue(BlogSrvContainerNS, blogAppKeyNS));
	  setTextFieldValue("bloggerUser", getTargetValue(BlogSrvContainerNS, blogUserNameNS));
	  setTextFieldValue("retrievePost", getTargetValue(BlogSrvContainerNS, blogRetrieveNumNS));
	  setTextFieldValue("bloggerPassword", loadPassword(getTargetValue(BlogSrvContainerNS, blogSrvUrlNS),
										   getTargetValue(BlogSrvContainerNS, blogUserNameNS)));
	  if (getTargetValue(BlogSrvContainerNS, blogPingBlogNS) == "true")
		document.getElementById("pingBlog").checked = true;
	  else
		document.getElementById("pingBlog").checked = false;

	/*	var blogSrvPref = Components.classes["@mozilla.org/preferences-service;1"]
								  .getService(Components.interfaces.nsIPrefService);
	  blogSrvPref = blogSrvPref.getBranch(parent.foobar);
	  getInput("bloggerUser").setAttribute("value", blogSrvPref.getCharPref("blogger.username"));
	  getInput("bloggerPassword").setAttribute("value", blogSrvPref.getCharPref("blogger.password"));*/
	}
  }

  function getTargetValue(subject, attribute)
  {
	return ds.GetTarget(subject, attribute, true)
			 .QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
  }

  function setTextFieldValue(inputName, value)
  {
	document.getElementById(inputName).setAttribute("value", value);
  }

  function getTextFieldValue(inputName)
  {
	return document.getElementById(inputName).value;
  }

  var xmlRpcClient;
  var xmlRpc = getXmlRpc();

  function getClient() {
	return Components.classes["@mozilla.org/xml-rpc/client;1"]
					 .createInstance(Components.interfaces.nsIXmlRpcClient);
  }

  function getXmlRpc() {
	if (!xmlRpcClient) xmlRpcClient = getClient();
	return xmlRpcClient;
  }

  function getUserBlog()
  {
	if (done == false)
	{
//		document.getElementById("blogDefault").setAttribute("label", "Loading...");

	  statusMessage += "\nServer: " + getTextFieldValue("bloggerServer");
	  statusMessage += "\nUsername/Password: " + getTextFieldValue("bloggerUser");
	  statusMessage += "/****** (hidden)\n";
	  document.getElementById("messageBox").value = statusMessage;

	  var serverurl = xmlRpc.createType(xmlRpc.STRING, {});
	  var blogAppkey = xmlRpc.createType(xmlRpc.STRING, {});
	  var username = xmlRpc.createType(xmlRpc.STRING, {});
	  var password = xmlRpc.createType(xmlRpc.STRING, {});
	  serverurl.data = getTextFieldValue("bloggerServer");
	  blogAppkey.data = getTextFieldValue("bloggerAppkey");
	  username.data = getTextFieldValue("bloggerUser");
	  password.data = getTextFieldValue("bloggerPassword");
	  xmlRpc.init(serverurl);
	  xmlRpc.asyncCall(blogInfoListener, null, "blogger.getUsersBlogs",
					   [blogAppkey, username, password], 3);
	  done = true;
	}
  }

  // open the site id list. If the list don't exist, it's created.
  // If it does it delete all prior entry with the right blogServer
  function openSiteIDList(ds)
  {
	var RDFContainer = Components.classes["@mozilla.org/rdf/container;1"]
								 .getService(Components.interfaces.nsIRDFContainer);
	var RDFContainerUtils = Components.classes["@mozilla.org/rdf/container-utils;1"]
									  .getService(Components.interfaces.nsIRDFContainerUtils);

	var blogSiteList = RDF.GetResource('http://www.exitspace.net/blog');
	var blogServerUrl = document.getElementById("bloggerServer").value;
	var blogUser = document.getElementById("bloggerUser").value;
	var BlogSrvContainerNS = RDF.GetResource(blogServerUrl + "#" + blogUser);
	var BlogSrvNS = RDF.GetResource("http://www.exitspace.net/blog/blogServer");

	if (!RDFContainerUtils.IsContainer(ds, blogSiteList))
	{
	  RDFContainer = RDFContainerUtils.MakeSeq(ds, blogSiteList);
	}
	RDFContainer.Init(ds, blogSiteList);

	// get the entries with the right blogServer
	var blogIDsForThisServer = ds.GetSources(BlogSrvNS, BlogSrvContainerNS, true);
	while(blogIDsForThisServer.hasMoreElements())
	{
	  var blogIDElement = blogIDsForThisServer.getNext();
	  blogIDElement = blogIDElement.QueryInterface(Components.interfaces.nsIRDFResource);
	  RDFContainer.RemoveElement(blogIDElement, true);
	}

	return RDFContainer;
  }

  // add the site ID to the list for the selected server.
  // also populate the site dropdown in the process
  // para1 = the blogInfo hash from blogger api
  // para2 = the site ID list to insert the site to
  function addSiteIDtoList(blogInfo, RDFContainer)
  {
//	  var blogList = document.getElementById("bloggerID");
	var blogName = blogInfo.getValue("blogName").QueryInterface(Components.interfaces.nsISupportsString);
	var blogSiteID = blogInfo.getValue("blogid").QueryInterface(Components.interfaces.nsISupportsString);
	var blogUrl = blogInfo.getValue("url").QueryInterface(Components.interfaces.nsISupportsString);
//	  blogList.appendItem(blogName.data, blogName.data);

	statusMessage += "\nFound " + blogName;
	document.getElementById("messageBox").value = statusMessage;

	blogName = RDF.GetLiteral(blogName);
	blogSiteID = RDF.GetLiteral(blogSiteID);
	blogUrl = RDF.GetResource(blogUrl);
	var blogSiteIDNS = RDF.GetResource("http://www.exitspace.net/blog/siteID");
	var blogSiteNameNS = RDF.GetResource("http://www.exitspace.net/blog/siteName");

	var blogServerUrl = document.getElementById("bloggerServer").value;
	var blogUser = document.getElementById("bloggerUser").value;
	var BlogSrvContainerNS = RDF.GetResource(blogServerUrl + "#" + blogUser);
	var BlogSrvNS = RDF.GetResource("http://www.exitspace.net/blog/blogServer");

	ds.Assert(blogUrl, blogSiteIDNS, blogSiteID, true);
	ds.Assert(blogUrl, blogSiteNameNS, blogName, true);
	ds.Assert(blogUrl, BlogSrvNS, BlogSrvContainerNS, true);

	RDFContainer.AppendElement(blogUrl);
  }

  var blogInfoListener = {
	onResult: function(client, ctxt, result) {
	  var localRDS = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	  if (localRDS.loaded)
	  {
		var RDFContainer = openSiteIDList(ds);

		var blogInfoResult = result.QueryInterface(Components.interfaces.nsISupportsArray);
		for (i = 0; i < blogInfoResult.Count(); i++) {
		  var blogInfo = blogInfoResult.QueryElementAt(i, Components.interfaces.nsIDictionary);
		  addSiteIDtoList(blogInfo, RDFContainer);
		}

		statusMessage += "\n\nSaving details...";
		document.getElementById("messageBox").value = statusMessage;

		// delete the loading dropdown menu item. UI tweak
//		  var blogList = document.getElementById("bloggerID");
//		  blogList.selectedIndex = 1;
//		  blogList.removeItemAt(0);

		var localRDS = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
		localRDS.Flush();
		ds = null;
		opener.populateServer();
		window.close();
	  }
	}, onFault: function(client, ctxt, fault) {
	  alert("Fault! " + fault + "\n");
	}, onError: function(client, ctxt, status, errorMsg) {
	  alert("Error! (" + status.toString(16) + ") " + errorMsg + "\n");
	}
  };

  // add a statement. If old value exist, change it. Else create a new one
  function addNode(subject, predicate, newValue)
  {
	var oldValue = ds.GetTarget(subject, predicate, true);
	if(oldValue)
	{
	  ds.Change(subject, predicate, oldValue, newValue);
	}
	else
	{
	  ds.Assert(subject, predicate, newValue, true)
	}
  }

  // save the currently selected server settings into rdf
  function saveServerInfo()
  {
	document.getElementById("panelDeck").setAttribute("selectedIndex", 1);
	statusMessage = "Checking setting...\n";
	document.getElementById("messageBox").value = statusMessage;

	var dialog = document.getElementById("channelDialog");
	dialog.getButton("accept").setAttribute("disabled", "true");
//	  dialog.getButton("cancel").setAttribute("disabled", "true");
	dialog.getButton("disclosure").setAttribute("disabled", "true");

	var blogServerUrl = document.getElementById("bloggerServer").value;
	var blogUser = document.getElementById("bloggerUser").value;
	var BlogSrvContainerNS = RDF.GetResource(blogServerUrl + "#" + blogUser);
	var blogSrvUrlNS = RDF.GetResource("http://www.exitspace.net/blog/serverUrl");
	var blogAppKeyNS = RDF.GetResource("http://www.exitspace.net/blog/appKey");
	var blogUserNameNS = RDF.GetResource("http://www.exitspace.net/blog/username");
	var blogPingBlogNS = RDF.GetResource("http://www.exitspace.net/blog/pingBlog");
	var blogRetrieveNumNS = RDF.GetResource("http://www.exitspace.net/blog/retrieveNum");

	addNode(BlogSrvContainerNS, blogSrvUrlNS, RDF.GetLiteral(getTextFieldValue("bloggerServer")));
	addNode(BlogSrvContainerNS, blogAppKeyNS, RDF.GetLiteral(getTextFieldValue("bloggerAppkey")));
	addNode(BlogSrvContainerNS, blogUserNameNS, RDF.GetLiteral(getTextFieldValue("bloggerUser")));
//	  addNode(BlogSrvContainerNS, blogPingBlogNS, RDF.GetLiteral(getTextFieldValue("pingBlog")));
	addNode(BlogSrvContainerNS, blogRetrieveNumNS, RDF.GetLiteral(getTextFieldValue("retrievePost")));

	if (document.getElementById("pingBlog").checked) {
	  addNode(BlogSrvContainerNS, blogPingBlogNS, RDF.GetLiteral("true"));
	} else {
	  addNode(BlogSrvContainerNS, blogPingBlogNS, RDF.GetLiteral("true"));
	}


	savePassword(getTextFieldValue("bloggerServer"), getTextFieldValue("bloggerUser"),
				 getTextFieldValue("bloggerPassword"));
	getUserBlog();
	return false; // don't close the window just yet
//	  var localRDS = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
//	  localRDS.Flush();
//	  ds = null;
  }

  var statusMessage = "";

  var done = false;

  ///////////////////////////////////////
  // Password manager utility functions
  //////////////////////////////////////

  function GetPasswordManager()
  {
	var gPasswordManager;
	var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].createInstance();
	if (passwordManager)
	  gPasswordManager = passwordManager.QueryInterface(Components.interfaces.nsIPasswordManager);
	return gPasswordManager;
  }

  function GetPasswordManagerInternal()
  {
	var gPasswordManagerInternal;
	try {
	  gPasswordManagerInternal =
		Components.classes["@mozilla.org/passwordmanager;1"].createInstance(
		Components.interfaces.nsIPasswordManagerInternal);
	} catch (e) {
	}
	return gPasswordManagerInternal;
  }

  function savePassword(url, user, password)
  {
	if (!url || !user || !password)
	  return false;

	var passwordManager = GetPasswordManager();
	if (passwordManager)
	{
	  // Remove existing entry
	  // (Note: there is no method to update a password for an existing entry)
	  try {
		passwordManager.removeUser(url, user);
	  } catch (e) {}

	  // If SavePassword is true, add new password
	  try {
		passwordManager.addUser(url, user, password);
	  } catch (e) {}
	  return true;
	}
	return false;
  }

  function loadPassword(url, user)
  {
	var passwordManagerInternal = GetPasswordManagerInternal();
	var host = {value:""};
	var username = {value:""};
	var password = {value:""};
	if (!passwordManagerInternal)
	  return false;
	try {
	  passwordManagerInternal.findPasswordEntry(url, user, "", host, username, password);
//		alert(host, username, password);
	  return password.value;
	} catch (e) {}
  }

