var urlStorage = function() {
  this.init();
}

urlStorage.prototype = {
  init : function() {
	this.list = new Array();
	this.lastIndex = 0;
	this.startIndex = 0;
  },
  setSource : function(newListing) {
	if (newListing) {
	  this.list = newListing;
	  return true;
	} else return null;
  },
  appendElement : function(element) {
	this.list[this.lastIndex] = element;
	this.lastIndex++;
  },
  retrieveElement : function() {
	var element = this.list[this.startIndex];
	this.startIndex++;
	return element;
  },
  currentElement : function() {
	if (this.startIndex != 0)
	  return this.list[this.startIndex - 1];
	else
	  return null;
  },
  get numOfElement() {
	return this.lastIndex;
  }
}

var xmlRpcClient;
var xmlRpc         = getXmlRpc();
var newSiteUrlList = new urlStorage();
var siteIDList     = new urlStorage();
var currentHtmlUrl = null; // the html page that is getting processed
var currentRssUrl  = null; // the result rss url

function getClient() {
  return Components.classes["@mozilla.org/xml-rpc/client;1"]
                   .createInstance(Components.interfaces.nsIXmlRpcClient);
}

function getXmlRpc() {
  if (!xmlRpcClient) xmlRpcClient = getClient();
  return xmlRpcClient;
}

function getSiteID(siteLocation)
{
  if (siteLocation) {
	currentHtmlUrl = siteLocation;
	var serverurl = xmlRpc.createType(xmlRpc.STRING, {});
	serverurl.data = "http://www.syndic8.com/xmlrpc.php";
	var siteURL = xmlRpc.createType(xmlRpc.STRING, {});
	siteURL.data = siteLocation;
	xmlRpc.init(serverurl);
	xmlRpc.asyncCall(getSiteIDListener, null, "syndic8.FindSites", [siteURL], 1);
  } else {
    var enumList = localDS.getSyndicationEnumList();
    while (enumList.hasMoreElements) {
      var list = enumList.getNext().QueryInterface(Components.interfaces.nsIRDFResource).Value;
      testRss = new RssParser(list);
      testRss.load();
    }
    document.getElementById("synd-progress").setAttribute("value", "50%");
    document.getElementById("statusbar-display").value = "loading datasource";
  }
}

var getSiteIDListener = {
  onResult: function(client, ctxt, result) {
    var dictResult = null;
    try {
      var urlResult = result.QueryInterface(Components.interfaces.nsISupportsArray);
      for (i = 0; i < urlResult.Count(); i++) {
        dictResult = urlResult.QueryElementAt(i, Components.interfaces.nsISupportsPRInt32);
        siteIDList.appendElement(dictResult.data);
      }
      getFeedInfo(siteIDList.retrieveElement());
    } catch (e) {
      dump("no site found");
    }
  }, onFault: function(client, ctxt, fault) {
    alert("Fault! " + fault + "\n");
  }, onError: function(client, ctxt, status, errorMsg) {
    alert("Error! (" + status.toString(16) + ") " + errorMsg + "\n");
  }
};

function getFeedInfo(feedIdent)
{
  if (feedIdent) {
//	  alert(feedIdent);
	var serverurl = xmlRpc.createType(xmlRpc.STRING, {});
    serverurl.data = "http://www.syndic8.com/xmlrpc.php";
	var dataUrl = xmlRpc.createType(xmlRpc.STRING, {});
	dataUrl.data = "dataurl";
	var dateChanged = xmlRpc.createType(xmlRpc.STRING, {});
	dateChanged.data = "date_xml_changed";
	// ^ sample return value <value><string>2002-04-05 09:09:13</string></value>
	var feedID = xmlRpc.createType(xmlRpc.INT, {});
	feedID.data = feedIdent;
	var siteIDs = xmlRpc.createType(xmlRpc.ARRAY, {});
	siteIDs.AppendElement(dataUrl);
//	  siteIDs.AppendElement(dateChanged);
	xmlRpc.init(serverurl);
	xmlRpc.asyncCall(getFeedInfoListener, null, "syndic8.GetFeedInfo", [feedID, siteIDs], 2);
  } else { // no more feed id to process, finalise the result

	// cleanup: it currently just grab the last entry, need to be smarter.
	var xmlFeed = RDF.GetResource("http://www.exitspace.net/xmlFeeds");
	if (currentRssUrl) { // if there is a valid xml feed
	  localDS.ds.Assert(RDF.GetResource(currentHtmlUrl), xmlFeed,
						 RDF.GetLiteral(currentRssUrl), true);
	} else {
	  localDS.ds.Assert(RDF.GetResource(currentHtmlUrl), xmlFeed,
						 RDF.GetLiteral("false"), true);
	}
    var localRDS = localDS.ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	localRDS.Flush();
	alert(currentHtmlUrl + " " + currentRssUrl);
	getSiteID(newSiteUrlList.retrieveElement());
	currentRssUrl = null;
  }
}

var getFeedInfoListener = {
  onResult: function(client, ctxt, result) {
	var dictResult = result.QueryInterface(Components.interfaces.nsIDictionary);
	var dictResult1 = dictResult.getValue("dataurl");
	dictResult1 = dictResult1.QueryInterface(Components.interfaces.nsISupportsString);
//	  alert(urlList.currentElement() + " " + dictResult1.data);
	currentRssUrl = dictResult1.data;
	getFeedInfo(siteIDList.retrieveElement());
  }, onFault: function(client, ctxt, fault) {
	alert("Fault! " + fault + "\n");
  }, onError: function(client, ctxt, status, errorMsg) {
	alert("Error! (" + status.toString(16) + ") " + errorMsg + "\n");
  }
};