/**
 * the sydnication tool works by downloading the list of updated sites.
 * passing it through the filter with bookmarks
 * the filter then generate an rdf source
 * the html is then generated from the rdf
 *
 *
 * It first initalise the local datasource that compliments bookmark/history
 * Then it load a list of recently updated sites
 * As it go through the site one by one it calls any function which want to
 * make use of it, such as generating html to produce a recently loaded site.
 */

include('chrome://jslib/content/io/io.js');

var syndPref = Components.classes["@mozilla.org/preferences-service;1"]
						 .getService(Components.interfaces.nsIPrefService);
syndPref     = syndPref.getBranch(null);

var fullPath	= null;
var localRdfUrl = null;
var fh			= null;
var rdfFh		= null;

init(); // initalise all the path name etc

var userTime	= 0;

var RDFContainerUtils = Components.classes["@mozilla.org/rdf/container-utils;1"]
								  .getService(Components.interfaces.nsIRDFContainerUtils);
var RDFRemoteContainer	  = Components.classes["@mozilla.org/rdf/container;1"]
								  .getService(Components.interfaces.nsIRDFContainer);
var RDFLocalContainer = Components.classes["@mozilla.org/rdf/container;1"]
                                  .getService(Components.interfaces.nsIRDFContainer);
var RDF 			  = Components.classes["@mozilla.org/rdf/rdf-service;1"]
								  .getService(Components.interfaces.nsIRDFService);

var SyndNamespace = RDF.GetResource('http://www.exitspace.net/syndication', true);

var bookmarkDS = RDF.GetDataSource("rdf:bookmarks");
var historyDS  = RDF.GetDataSource("rdf:history");

var localSource;	// local rdf handle
var remoteSource  = null;

var localRDS	  = null;
var newRdfListing = null;

var sepFound	  = false;
var sepIndex	  = 0;

function init()
{
  var du = new DirUtils();
  var userDir = du.getMozUserHomeDir();
  var fu = new FileUtils();
  fullPath = fu.append(userDir, "syndicationTmp.html");
  fh = new File(fullPath);
  var rdfFullPath  = fu.append(userDir, "syndicationTmp.rdf");
  rdfFh = new File(rdfFullPath);
  var RDF       = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                            .getService(Components.interfaces.nsIRDFService);
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                            .getService(Components.interfaces.nsIIOService);
  localRdfUrl   = ioService.newFileURI(rdfFh.nsIFile);

  if (fu.exists(fullPath)) {
	fh = new File(fullPath);
	fh.open();
	var regex = /<!--(\d+)-->/gi;
	var fileContent = fh.readline();
	regex.exec(fileContent);
	fh.close();
	userTime = parseInt(RegExp.$1);
  } else {
	userTime = 0;
  }
}

function loadLocalFeed()
{
  // create empty template if rdf dont exist
  var RDF       = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                            .getService(Components.interfaces.nsIRDFService);
  localSource   = RDF.GetDataSource('file:///C:/rssFeed.rdf');	// local rdf handle
  if (!rdfFh.exists()) {
	rdfFh.open('w');
	rdfFh.write('<?xml version="1.0"?>\n<RDF:RDF xmlns:RDF=' +
				'"http://www.w3.org/1999/02/22-rdf-syntax-ns#">\n</RDF:RDF>\n');
	rdfFh.close();
  }
  localRDS = localSource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
  if (localRDS.loaded) {
	localRDS.Refresh(false);
	dump("the datasource was already loaded!\n");
  } else {
	dump("the datasource wasn't loaded, but it's loading now!\n");
  }

  var localSink = localSource.QueryInterface(Components.interfaces.nsIRDFXMLSink);
  localSink.addXMLSinkObserver(ObserverLocalRDF);
}

var ObserverLocalRDF = {
  onBeginLoad: function(aSink) {},
  onInterrupt: function(aSink) {},
  onResume: function(aSink) {},
  onEndLoad: function(aSink)
  {
    RDFContainerUtils = Components.classes["@mozilla.org/rdf/container-utils;1"]
	                                  .getService(Components.interfaces.nsIRDFContainerUtils);
    RDFLocalContainer = Components.classes["@mozilla.org/rdf/container;1"]
                                      .getService(Components.interfaces.nsIRDFContainer);
    if (!RDFContainerUtils.IsContainer(localSource, SyndNamespace)) {
	  RDFContainerUtils.MakeSeq(localSource, SyndNamespace);
       alert("erm");
    }
    RDFLocalContainer.Init(localSource, SyndNamespace);
    alert(RDFLocalContainer.GetCount());
	//writeLocalRdf(newRdfListing);
	//genOutput(); // generate html from local rdf
	//loadDisplay();
	document.getElementById("statusbar-display").value = "Data source loaded";
	//var localSink = localSource.QueryInterface(Components.interfaces.nsIRDFXMLSink);
	aSink.removeXMLSinkObserver(this);
  },
  onError: function(aSink, aStatus, aErrorMsg) { alert("error! " + aErrorMsg); }
};


function InsertSiteEntry(bookmarkEntry, index)
{
//alert(bookmarkEntry);
  bookmarkEntry = RDF.GetResource(bookmarkEntry);
  if (RDFLocalContainer.IndexOf(bookmarkEntry) != -1) {
    RDFLocalContainer.RemoveElement(bookmarkEntry, true);
  }
  RDFLocalContainer.InsertElementAt(bookmarkEntry, index, true);
}

/**
 * generate a html output from rdf
 *//*
function genOutput()
{
  var thisresult = "";
  var RDFLocalContainer = Components.classes["@mozilla.org/rdf/container;1"]
									.getService(Components.interfaces.nsIRDFContainer);
  RDFLocalContainer.Init(localSource, SyndNamespace);
  var result = RDFLocalContainer.GetElements();

  syndContent = "<!--" + newRdfListing[0] + "-->\n";
  syndContent += "<font size='-1'><ul style='margin-left: -2em'>";
  try {
	MAXCOUNT = syndPref.getIntPref("syndication.maxNumEntry");
  } catch (e) {
	MAXCOUNT = 20;
  }
  try {
	listCount = RDFLocalContainer.GetCount();
  } catch (e) {
	listCount = 0;
  }
  if (listCount > MAXCOUNT) {
	listCount = MAXCOUNT;
  }
  for (count = 0; count < listCount; count++) {
	thisresult = result.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	if (count == (sepIndex)) {
	  if (sepFound == true) {
		var myTime = new Date(parseInt(newRdfListing[0]) * 1000);
//		  syndContent += "<li>" + myTime.toGMTString() + "</li>";
		syndContent += "----";
	  }
	}
	var bookmarkName = bookmarkDS.GetTarget(RDF.GetResource(thisresult.Value),
											RDF.GetResource('http://home.netscape.com/NC-rdf#Name'),
											true);
	if (bookmarkName) {
	  tempName = bookmarkName.QueryInterface(Components.interfaces.nsIRDFLiteral);
	  tempName = tempName.Value;
	  stripName = new String(tempName);
	  newName = stripName.slice(0, 21);
	  newName += "..";
	} else {
	  tempName = thisresult.Value
	}
	syndContent += "<li><a href='" + thisresult.Value +
				   "' target='window.top' style='color: blue; text-decoration: underline'" +
				   "title='" + tempName + "'>" + newName + "</a></li>";
  }
  syndContent += "</ul></font>";
  if (!fh.exists()) {
	fh.create();
  }
  fh.open('w');
  fh.write(syndContent);
  fh.close();
}

function checkSiteInfo(siteUrl)
{
  if (!RDFContainerUtils.IsContainer(localSource, SyndNamespace))
  {
	RDFContainerUtils.MakeSeq(localSource, SyndNamespace);
  }
  RDFLocalContainer.Init(localSource, SyndNamespace);
  var siteRS = RDF.GetResource(siteUrl);
  var xmlFeed = RDF.GetResource("http://www.exitspace.net/xmlFeeds");
  var result = RDFLocalContainer.IndexOf(siteRS);
  if (result == -1)
  {
	// insert site into datasource
	RDFLocalContainer.AppendElement(siteRS, true);
  }

  result = localSource.GetTarget(siteRS, xmlFeed, true);
  if(result)
  {
	result = result.QueryInterface(Components.interfaces.nsIRDFLiteral);
	if (result.Value != "false")
	{
	  // load the rss into array for batch processing later
	  return result.Value;
	}
  }
  else
  {
	// load site url into array for batch processing later
	newSiteUrlList.appendElement(siteUrl);
  }
  return false;
}
*/
/**
 * get the list and extract the urls
 */
function getBookmarkedList(syndicateSource)
{
  var list = new Array();
  var aCount = 0;
  RDFRemoteContainer.Init(remoteSource, RDF.GetResource('http://www.weblogs.com/', true));
  if (RDFRemoteContainer)
  {
	result = RDFRemoteContainer.GetElements();
	// handle the first element, which is the timestamp
    if(result.hasMoreElements())
	  thisresult = result.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	userTime = parseInt(thisresult.Value);
	dump("New source timestamp: " + userTime);

    while(result.hasMoreElements()) {
	  thisresult = result.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	  bookmark = matchBookmark(thisresult);
	  if (bookmark) {
		//var toLoad = checkSiteInfo(bookmark);
		//if (toLoad) {
          InsertSiteEntry(thisresult.Value, aCount);
		  aCount++;
		//}
	  }
	}
	document.getElementById("synd-progress").setAttribute("value", "100%");
	document.getElementById("statusbar-display").value = "Loading site summary";
/*	if (newSiteUrlList.numOfElement != 0) {
	   get site rss url
	  getSiteID(newSiteUrlList.retrieveElement());
	}
	else {
	   get rss
	  saveRSS(list);
	}*/
  }
  else {
	document.getElementById("statusbar-display").value = "Error merging bookmarks";
  }
  localRDS = localSource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
  localRDS.Flush();
  return list;
}

/**
 * find the urls that are also in the bookmarks
 */
function matchBookmark(bookmarkResource)
{
  // for some reason it only verify bookmark existance using namespace other than the urls
  // hence the hack
  var rdfnode = bookmarkDS.GetTarget(bookmarkResource,
									 RDF.GetResource('http://home.netscape.com/NC-rdf#Name'),
									 true);
  if (rdfnode)
  {
	//return rdfnode.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
    return true;
  }
  else
  {
	return null;
  }
}

/**
 * observer for getUpdateList() loading remote rdf
 */
var ObserverRemoteRDF = {
  onBeginLoad: function(aSink) {},
  onInterrupt: function(aSink) {},
  onResume: function(aSink) {},
  onEndLoad: function(aSink)
  {
	document.getElementById("statusbar-display").value = "Checking sites";
	document.getElementById("synd-progress").setAttribute("mode", "determined");
	document.getElementById("synd-progress").setAttribute("value", "0%");
	var updateList = getBookmarkedList(remoteSource); // return bookmark list
	// RDF/XML Datasources are all nsIRDFXMLSinks
	var remoteSink = remoteSource.QueryInterface(Components.interfaces.nsIRDFXMLSink);
	// remove the observer to the datasource-as-sink
	remoteSink.removeXMLSinkObserver(ObserverRemoteRDF);
  },
  onError: function(aSink, aStatus, aErrorMsg) { dump("error! " + aErrorMsg); }
};

/**
 * the notifcation system for updating the list
 */
function getUpdateList()
{
  //loadLocalFeed();
  var rdfUrl = "file:///c:/weblogs.php.rdf"
  //var rdfUrl = "http://www.exitspace.net/utils/syndication/weblogs.php?userTime=" + userTime;
  var RDF 			  = Components.classes["@mozilla.org/rdf/rdf-service;1"]
								  .getService(Components.interfaces.nsIRDFService);
  remoteSource = RDF.GetDataSource(rdfUrl);
  var remote = remoteSource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
  if (remote.loaded)
  {
	document.getElementById("statusbar-display").value = "Refreshing news list";
	document.getElementById("synd-progress").setAttribute("mode", "undetermined");
	remote.Refresh(false);
  }
  else
  {
	document.getElementById("statusbar-display").value = "Getting news list";
	document.getElementById("synd-progress").setAttribute("mode", "undetermined");
  }
  // RDF/XML Datasources are all nsIRDFXMLSinks
  var sink = remoteSource.QueryInterface(Components.interfaces.nsIRDFXMLSink);
  // Attach the observer to the datasource-as-sink
  sink.addXMLSinkObserver(ObserverRemoteRDF);
}
