/**
 * localSyndicationRDF: handler for syndicationTmp.html
 * it adds site to list as well as other site attributes such as rss feed location
 **/
function localSyndicationRDF() {
  this.init();
}

localSyndicationRDF.prototype = {
  RDF : null,
  localRDS : null,
  RDFContainerUtils : null,
  RDFLocalContainer : null,
  ds : null,
  syndNamespace : null,

  init : function()
  {
  // create empty template if rdf dont exist
    this.RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                         .getService(Components.interfaces.nsIRDFService);
    this.RDFContainerUtils = Components.classes["@mozilla.org/rdf/container-utils;1"]
	                                  .getService(Components.interfaces.nsIRDFContainerUtils);
    this.RDFLocalContainer = Components.classes["@mozilla.org/rdf/container;1"]
                                      .createInstance(Components.interfaces.nsIRDFContainer);
    this.syndNamespace = RDF.GetResource('http://www.exitspace.net/syndication');

    this.ds   = getRDFHandle("syndicationTmp.rdf");	// local rdf handle
    this.localRDS = this.ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
    if (this.localRDS.loaded) {
	  this.localRDS.Refresh(false);
	  dump("the datasource was already loaded!\n");
    } else {
	  dump("the datasource wasn't loaded, but it's loading now!\n");
    }
    var localSink = this.ds.QueryInterface(Components.interfaces.nsIRDFXMLSink);
    localSink.addXMLSinkObserver(this);
  },

  getSyndicationEnumList : function()
  {
    return this.RDFLocalContainer.GetElements();
  },

  test : function()
  {
    alert(this.RDFLocalContainer.Resource.Value);
  },

  InsertSiteEntry : function(bookmarkEntry, index)
  {
    if (this.RDFLocalContainer.IndexOf(bookmarkEntry) != -1) {
      this.RDFLocalContainer.RemoveElement(bookmarkEntry, true);
    }
    //alert(this.RDFLocalContainer.Resource.Value);
    this.RDFLocalContainer.InsertElementAt(bookmarkEntry, index, true);
  },

  setRSSEntry : function(siteResource, rssResource)
  {
  },

  get lastUpdate()
  {
    var syndication = RDF.GetResource("http://www.exitspace.net/syndication/syndication");
    var lastUpdate = RDF.GetResource("http://www.exitspace.net/syndication/lastUpdate");
    var result = this.ds.GetTarget(siteResource, xmlFeed, true);
    if (result) {
      return result.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
    } else {
      return 0;
    }
  },

  set lastUpdate(newTimeStamp)
  {
    var syndication = RDF.GetResource("http://www.exitspace.net/syndication/syndication");
    var lastUpdate = RDF.GetResource("http://www.exitspace.net/syndication/lastUpdate");
    updateAssertion(this.ds, syndication, lastUpdate, RDF.GetLiteral(newTimeStamp));
  },

  checkRSSEntry : function(siteResource)
  {
    var xmlFeed = RDF.GetResource("http://www.exitspace.net/xmlFeeds");
    var result = this.ds.GetTarget(siteResource, xmlFeed, true);
    if(result) {
      result = result.QueryInterface(Components.interfaces.nsIRDFLiteral);
      if (result.Value != "none") {
        return result.Value;
      } else
        return "none";
    } else {
      return false;
    }
  },

  save : function()
  {
    this.localRDS.Flush();
  },

  onBeginLoad: function(aSink) {},
  onInterrupt: function(aSink) {},
  onResume: function(aSink) {},
  onEndLoad: function(aSink)
  {
    if (!this.RDFContainerUtils.IsContainer(this.ds, this.syndNamespace)) {
	  this.RDFContainerUtils.MakeSeq(this.ds, this.syndNamespace);
    }
    this.RDFLocalContainer.Init(this.ds, this.syndNamespace);
	document.getElementById("statusbar-display").value = "Data source loaded";
	aSink.removeXMLSinkObserver(this);
  },
  onError: function(aSink, aStatus, aErrorMsg) { alert("error! " + aErrorMsg); }
}