/**
 * syndicationSource: an object to process the remote rdf (rdfied weblogs.com list)
 * it loads the remote list and goes through comparing each entry with the bookmarks
 * it stores any matches to localdisk using localSyndicationRDF instanace
 * all match are also checked for xml (rss) feeds using localSyndicationRDF instance
 **/
function syndicationSource(url) {
  this.init(url);
}

syndicationSource.prototype = {
  RDF : null,
  RDFContainerUtils : null,
  RDFRemoteContainer : null,
  ds  : null,
  remoteRDS  : null,
  aCount : null,
  newSiteUrlList : null,
  list : null,

  init : function(url)
  {
    var rdfUrl = url
    this.RDF   = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                           .getService(Components.interfaces.nsIRDFService);
    this.RDFContainerUtils = Components.classes["@mozilla.org/rdf/container-utils;1"]
	                                  .getService(Components.interfaces.nsIRDFContainerUtils);
    this.RDFRemoteContainer = Components.classes["@mozilla.org/rdf/container;1"]
                                      .createInstance(Components.interfaces.nsIRDFContainer);
    this.ds = RDF.GetDataSource(rdfUrl);
    this.remoteRDS = this.ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
    if (this.remoteRDS.loaded) {
	  document.getElementById("statusbar-display").value = "Refreshing news list";
	  document.getElementById("synd-progress").setAttribute("mode", "undetermined");
	  this.remoteRDS.Refresh(false);
    } else {
	  document.getElementById("statusbar-display").value = "Getting news list";
	  document.getElementById("synd-progress").setAttribute("mode", "undetermined");
    }
    var sink = this.ds.QueryInterface(Components.interfaces.nsIRDFXMLSink);
    sink.addXMLSinkObserver(this);
  },

  parseSyndicateList : function()
  {
    this.list = new Array();
    this.aCount = 0;
    this.RDFRemoteContainer.Init(this.ds, RDF.GetResource('http://www.weblogs.com/'));
    if (this.RDFRemoteContainer) {
	  var result = this.RDFRemoteContainer.GetElements();

      if(result.hasMoreElements()) // handle the first element, which is the timestamp
        thisResult = result.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	  var userTime = parseInt(thisResult.Value);
	  dump("New source timestamp: " + userTime);

      while(result.hasMoreElements()) {
	    thisResult = result.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	    this.checkBookmark(thisResult);
	  }

      if (newSiteUrlList.numOfElement != 0) { // if there is sites with no rss entry
        getSiteID(newSiteUrlList.retrieveElement());
        document.getElementById("synd-progress").setAttribute("value", "25%");
        document.getElementById("statusbar-display").value = "finding datasource";
      }
    } else {
    testRss = new RssParser(this.list);
    testRss.load();
    document.getElementById("statusbar-display").value = "Error merging bookmarks";
    }
    localDS.save();
  },

  checkBookmark : function(bookmark)
  {
    // for some reason it only verify bookmark existance using namespace other than the urls
    var rdfnode = bookmarkDS.GetTarget(bookmark,
                  RDF.GetResource('http://home.netscape.com/NC-rdf#Name'), true);
    if (rdfnode) {
      localDS.InsertSiteEntry(bookmark, this.aCount+1);
      var rssEntry = localDS.checkRSSEntry(bookmark);
      if (!rssEntry) {
        newSiteUrlList.appendElement(bookmark.Value);
      } else {
        this.list[this.aCount] = rssEntry;
      }
      this.aCount++;
    } else {
	  return false;
    }
  },

  onBeginLoad: function(aSink) {},
  onInterrupt: function(aSink) {},
  onResume: function(aSink) {},
  onEndLoad: function(aSink)
  {
	document.getElementById("statusbar-display").value = "Checking sites";
	document.getElementById("synd-progress").setAttribute("mode", "determined");
	document.getElementById("synd-progress").setAttribute("value", "0%");
	this.parseSyndicateList(); // return bookmark list
	aSink.removeXMLSinkObserver(this);
  },
  onError: function(aSink, aStatus, aErrorMsg) { dump("error! " + aErrorMsg); }
}
