  var gRssDs;

  var xmlDoc = document.implementation.createDocument("", "test", null);

  var urlList = null;
  var currentCount = 0;

  var rssObserver = {
	onBeginLoad: function(aSink) {},
	onInterrupt: function(aSink) {},
	onResume: function(aSink)	 {},
	onEndLoad: function(aSink)
	{
	  loadRSSList(urlList);
	  aSink.removeXMLSinkObserver(this);
	},
	onError: function(aSink, aStatus, aErrorMsg) { alert("error! " + aErrorMsg); }
  };

  var saveRSS = function(remoteUrl)
  {
	urlList = remoteUrl;
	var profileComponent = Components.classes["@mozilla.org/profile/manager;1"].createInstance();
	var profileInternal = profileComponent.QueryInterface(Components.interfaces.nsIProfileInternal);
	var rssFile = profileInternal.getProfileDir(profileInternal.currentProfile);
	rssFile.append("rssStore.rdf");
	if (!rssFile.exists())
	{
	  var fileOut = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance();
	  var outStream = fileOut.QueryInterface(Components.interfaces.nsIFileOutputStream);
	  var rssTemplate = '<?xml version="1.0"?>\n<RDF:RDF xmlns:RDF=';
	  rssTemplate	 += '"http://www.w3.org/1999/02/22-rdf-syntax-ns#"\n';
	  rssTemplate	 += 'xmlns="http://purl.org/rss/1.0/">\n</RDF:RDF>\n';

	  // flag from nsIFile.idl
	  var NORMAL_FILE_TYPE = 0;
	  // flags from prio.h [ http://lxr.mozilla.org/seamonkey/source/nsprpub/pr/include/prio.h ]
	  var WRITE_ONLY	   = 0x02;
	  var OWNER_WRITE	   = 00200;

	  rssFile.create(NORMAL_FILE_TYPE, 755);
	  outStream.init(rssFile, WRITE_ONLY, OWNER_WRITE, 0);
	  outStream.write(rssTemplate, rssTemplate.length);
	  outStream.close();
	}

	var myRSS = new rssNamespace();
	var ioService = Components.classes["@mozilla.org/network/io-service;1"]
							  .getService(Components.interfaces.nsIIOService);
	var RSSUrl = ioService.newFileURI(rssFile);
	var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1']
					.getService(Components.interfaces.nsIRDFService);
/*	  ds = Components.
			 classes['@mozilla.org/rdf/datasource?name=in-memory-datasource;1'].
			 createInstance();*/
	var ds = RDF.GetDataSource(RSSUrl.spec);
	gRssDs = ds;

	var localRDS = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	if (localRDS.loaded)
	{
	  // block loading
	  dump("the datasource was already loaded!\n");
	  loadRSSList(urlList);
	}
	else
	{
	  dump("the datasource wasn't loaded, but it's loading now!\n");
	  var sink = ds.QueryInterface(Components.interfaces.nsIRDFXMLSink);
	  sink.addXMLSinkObserver(rssObserver);
	}
  }

  var loadRSSList = function(remoteUrl)
  {
	var remoteURL = remoteUrl[currentCount];
	  alert(remoteURL);
	xmlDoc.addEventListener("load", documentLoaded, false);
	xmlDoc.load(remoteURL);
  }

  var documentLoaded = function(e)
  {
	var errorMsg = "";
	var rssNode = xmlDoc.getElementsByTagName("rss");
	try {
	  var rssVersion = rssNode[0].getAttribute("version");
	} catch (e) {
	  var htmlTag = xmlDoc.getElementsByTagName("html").length;
	  if (htmlTag <= 0) {
		rssVersion = "1.0";
	  } else {
		rssVersion = null;
		alert("This is not a valid RSS file");
	  }
	}

	if (rssVersion == "0.91" || rssVersion == "0.92"){
	  processZeroPointNine();
	} else if (rssVersion == "1.0") {
	  processZeroPointNine();
	} else {
	  alert ("Error has occured, only RSS is supported currently");
	}

	currentCount++;
	var URLcount = urlList.length;
//	  alert(currentCount + ":" + URLcount);
	if (currentCount < URLcount) {
	  loadRSSList(urlList);
	} else {
	  renderHTML();
	  currentCount = 0;
	}
//	  eval(dsListener + "(ds);");
  }

function processZeroPointNine()
{
  var myRSS = new rssNamespace();
  var ds = gRssDs;
  var remoteURL = urlList[currentCount];
  var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1']
					  .getService(Components.interfaces.nsIRDFService);
  var channelNS = RDF.GetResource(remoteURL);
  var rssChannel = xmlDoc.getElementsByTagName("channel");
  try {
	var channelTitle = rssChannel[0].getElementsByTagName("title")[0].firstChild.data;
  } catch (e) {
	channelTitle = "";
  }
  try {
	var channelLink = rssChannel[0].getElementsByTagName("link")[0].firstChild.data;
  } catch (e) {
	channelLink = remoteURL;
  }
  try {
	var channelDescription = rssChannel[0].getElementsByTagName("description")[0].firstChild.data;
  } catch (e) {
	channelDescription = "";
  }
  var RSSItemContainerNS = RDF.GetResource(remoteURL + "#sequence");

  if (!ds.HasAssertion(channelNS, myRSS.linkNS, RDF.GetLiteral(channelLink), true)) {
	ds.Assert(channelNS, myRSS.rdfTypeNS, myRSS.channelNS, true);
	ds.Assert(channelNS, myRSS.titleNS, RDF.GetLiteral(channelTitle), true);
	ds.Assert(channelNS, myRSS.linkNS,	RDF.GetLiteral(channelLink), true);
//	  ds.Assert(channelNS, myRSS.descNS,  RDF.GetLiteral(channelDescription), true);
	ds.Assert(channelNS, myRSS.itemsNS, RSSItemContainerNS, true);
  }

  var RDFContainer = Components.classes["@mozilla.org/rdf/container;1"]
							   .getService(Components.interfaces.nsIRDFContainer);
  var RDFContainerUtils = Components.classes["@mozilla.org/rdf/container-utils;1"]
									.getService(Components.interfaces.nsIRDFContainerUtils);
  if (!RDFContainerUtils.IsContainer(ds, RSSItemContainerNS))
  {
	myContainer = RDFContainerUtils.MakeSeq(ds, RSSItemContainerNS);
  }
  RDFContainer.Init(ds, RSSItemContainerNS);
  var rssItems = xmlDoc.getElementsByTagName("item");

  for (var i = 0; i < rssItems.length; i++)
  {
	try {
	  var titleData = rssItems[i].getElementsByTagName("title")[0].firstChild.data;
	} catch (err) {
	  titleData = "story" + i;
	}
	try {
	  var descData = rssItems[i].getElementsByTagName("description")[0].firstChild.data;
	} catch (err) {
	  descData = "";
	}
	try {
	  var linkData = rssItems[i].getElementsByTagName("link")[0].firstChild.data;
	} catch (err) {
	  linkData = remoteURL + "#" + titleData;
	}

	var linkResource = RDF.GetResource(linkData);
	var linkLiteral  = RDF.GetLiteral(linkData);
	var titleLiteral = RDF.GetLiteral(titleData);
	var descLiteral  = RDF.GetLiteral(descData);

	if (!ds.HasAssertion(linkResource, myRSS.titleNS, titleLiteral, true)) {
	  ds.Assert(linkResource, myRSS.rdfTypeNS, myRSS.itemNS, true);
	  ds.Assert(linkResource, myRSS.titleNS, titleLiteral, true);
	  ds.Assert(linkResource, myRSS.linkNS,  linkLiteral, true);
	  ds.Assert(linkResource, myRSS.descNS,  descLiteral, true);
	  RDFContainer.AppendElement(linkResource, true);
	}
  }

  var localRDS = ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
  localRDS.Flush();
}

var rssNamespace = function()
{
  this.init();
}

rssNamespace.prototype =
{
  init : function()
  {
	this.RDF = Components.classes['@mozilla.org/rdf/rdf-service;1']
						 .getService(Components.interfaces.nsIRDFService);
  },
  get channelNS()
  {
	this.channel  = this.RDF.GetResource("http://purl.org/rss/1.0/channel");
	return this.channel;
  },
  get itemsNS()
  {
	this.items	  = this.RDF.GetResource("http://purl.org/rss/1.0/items");
	return this.items;
  },
  get itemNS()
  {
	this.item	  = this.RDF.GetResource("http://purl.org/rss/1.0/item");
	return this.item;
  },
  get titleNS()
  {
	this.title	  = this.RDF.GetResource("http://purl.org/rss/1.0/title");
	return this.title;
  },
  get linkNS()
  {
	this.link	  = this.RDF.GetResource("http://purl.org/rss/1.0/link");
	return this.link;
  },
  get descNS()
  {
	this.desc	  = this.RDF.GetResource("http://purl.org/rss/1.0/description");
	return this.desc;
  },
  get rdfTypeNS()
  {
	this.rdfType  = this.RDF.GetResource("http://www.w3.org/1999/02/22-rdf-syntax-ns#type");
	return this.rdfType;
  }
}

