function rssOnLoadListener(event)
{
  testRss.parseRss();
}

function RssParser(urlList) {
  this.init(urlList);
}

RssParser.prototype = {
  xmlDoc : null,
  listCount : null,
  template : null,
  init : function(urlList)
  {
    this.urlList = urlList;
    this.template = new outputTemplate();

    this.listCount = 0;
  },

  load : function()
  {
    if (this.listCount < this.urlList.length) {
      this.xmlDoc = document.implementation.createDocument("", "", null);
      this.xmlDoc.onload = rssOnLoadListener;
      alert(this.urlList[this.listCount]);
      this.xmlDoc.load(this.urlList[this.listCount++]);
    } else {
      var profileComponent = Components.classes["@mozilla.org/profile/manager;1"].createInstance();
      var profileInternal = profileComponent.QueryInterface(Components.interfaces.nsIProfileInternal);
      var syndicateFile = profileInternal.getProfileDir(profileInternal.currentProfile);
      var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                                .getService(Components.interfaces.nsIIOService);
      var syndicateUrl = ioService.newFileURI(syndicateFile);
      var fileStore = new localStore(syndicateUrl.spec);
      fileStore.saveFile("tempRSS.html", this.template.output());
      document.getElementById("synd-progress").setAttribute("value", "100%");
      document.getElementById("statusbar-display").value = "Newsfeed finish loading";
    }
  },

  parseRss : function()
  {
//    this.xmlDoc = event.currentTarget;
//    var rssNode = this.xmlDoc.getElementsByTagName("rss");
    //alert(rssNode[0].getAttribute("version"));

    var rssChannel = this.xmlDoc.getElementsByTagName("channel");
  if (rssChannel[0]) {

    var channelChild = rssChannel[0].childNodes;
    var title = "";
    var link = "";
    var description = "";
    for (var i = 0; i < channelChild.length; i++) {
      var channelAttribute = channelChild[i];
      switch (channelAttribute.nodeName)
      {
        case "title" : if(channelAttribute.firstChild) title = channelAttribute.firstChild.data
        break;
        case "link" : if(channelAttribute.firstChild) link = channelAttribute.firstChild.data
        break;
        case "description" : if(channelAttribute.firstChild) description = channelAttribute.firstChild.data
        break;
      }
    }
    this.template.saveHeading(link, title, description);
    var rssItems = this.xmlDoc.getElementsByTagName("item");
    for (var i = 0; i < rssItems.length; i++) {
      var rssItemsChild = rssItems[i].childNodes;
      for (var j = 0; j < rssItemsChild.length; j++) {
        var rssItemName = rssItemsChild[j];
        switch (rssItemName.nodeName)
        {
          case "title" : if(rssItemName.firstChild) title = rssItemName.firstChild.data
          break;
          case "link" : if(rssItemName.firstChild) link = rssItemName.firstChild.data
          break;
          case "description" : if(rssItemName.firstChild) description = rssItemName.firstChild.data
          break;
        }
      }
      this.template.saveBodyEntry(link, title, description);
    }
    this.template.saveEntry();
  }else alert('doh');
    this.load();
  }
}

var testRss;

var loadRSSList = function()
{
  var list = new Array();
  list[0] = "http://ln.hixie.ch/?command=RSS";
  list[1] = "http://inessential.com/xml/rss.xml";
  list[2] = "http://snowdeal.org/syndication/machina.rdf";
  list[3] = "http://www.mozillazine.org/weblogs/hyatt/blogger_rss.xml";
  testRss = new RssParser(list);
  testRss.load();
}

function outputTemplate() {
  this.init();
}

outputTemplate.prototype = {
  heading : null,
  body : null,
  content : null,
  init : function()
  {
    this.content = "";
    this.heading = "";
    this.body = "";
  },
  saveHeading : function(channelLink, channelTitle, channelDescription)
  {
    this.heading = "<tr><th bgcolor='#ffcc33' align='left'><a href='" + channelLink + "'>"
                 + channelTitle + "</a></th></tr>"
  },
  saveBodyEntry : function(itemLink, itemTitle, itemDescription)
  {
    //itemDescription = itemDescription.slice(0, 500);
    this.body += "<tr><td><strong>[<a href='" + itemLink + "'>" + itemTitle + "</a>]</strong> "
              + itemDescription + "</td></tr>"
  },
  saveEntry : function()
  {

    var tempContent = this.heading + this.body + this.content;
    this.heading = "";
    this.body = "";
    this.content = tempContent;
  },
  output : function()
  {
    return "<html><head><title>News Feed</title></head><body><table width='90%' align='center' border='1'>" +
           this.content + "</table></body></html>";
  }
}