var RDF =
  Components
  .classes["@mozilla.org/rdf/rdf-service;1"]
  .getService(Components.interfaces.nsIRDFService);

var DS =
  Components
  .classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"]
  .createInstance(Components.interfaces.nsIRDFDataSource);

function init()
{
  // Create three resources (urn:1, urn:2, and urn:3) that are
  // children of urn:root
  for (var i = 1; i <= 3; ++i) {
	DS.Assert(RDF.GetResource("urn:root"),
			  RDF.GetResource("http://home.netscape.com/NC-rdf#child"),
			  RDF.GetResource("urn:" + i),
			  true);

	DS.Assert(RDF.GetResource("urn:" + i),
			  RDF.GetResource("http://home.netscape.com/NC-rdf#name"),
			  RDF.GetLiteral("Number " + i),
			  true);
  }

  // Add the datasource to the outliner
  var outliner = document.getElementById("outliner");
  outliner.database.AddDataSource(DS);
  outliner.setAttribute("ref", "urn:root");
}

// This will remember the index of the last child we've added
var Kid = 1;

function make_kid()
{
  // Add a new child urn:1.x beneath urn:1.
  DS.Assert(RDF.GetResource("urn:1." + Kid),
			RDF.GetResource("http://home.netscape.com/NC-rdf#name"),
			RDF.GetLiteral("Number 1." + Kid),
			true);

  DS.Assert(RDF.GetResource("urn:1"),
			RDF.GetResource("http://home.netscape.com/NC-rdf#child"),
			RDF.GetResource("urn:1." + Kid),
			true);

  ++Kid;
}

